" X window --- AAWindow tests. "
"
*
* This should open up a window on the given host (should really prompt, or check
* out the $DISPLAY variable). The window should refresh itself if you run the
* disp wpe line repeatedly.
* 
* test8.self,v 1.6 1993/07/13 21:47:04 richards Exp
*
* test8.self,v
# Revision 1.6  1993/07/13  21:47:04  richards
# July 13 checkin.
#
# Revision 1.5  1993/06/24  21:24:33  richards
# Split drawing out of boites and into light weight views.
#
# Revision 1.4  1993/06/18  21:25:42  richards
# Moved font support into viewManager.
# Starting to add selection stuff into window and boite.
# Boites refer properly back to the polynomial structures.
#
# Revision 1.3  1993/06/03  21:33:16  richards
# Fixed up the redrawing of the subviews. Turned out they were being drawn off the screen
# due to faulty thinking about where the areas really were.
#
# Revision 1.2  1993/06/02  21:17:08  richards
# I am slowly dealing with window redrawing and resizing requests and getting deeper
# into navel and X. The problem is either too many configureNotify requests, or not enough
# of them. Also, there seems to be some kind of problem filing window.self in twice.
#
# Revision 1.1  1993/05/31  15:00:14  richards
# Changed the view to be two views: topView and an equationView. topView is divided up nicely.
#
# Revision 1.1  1993/05/31  00:12:18  richards
# May 30 checkin. Font support is nearly debugged.
# Make use of glue now.
# Added rational (fraction) types.
#
* Revision 1.2  1993/05/30  21:47:01  richards
* Tests include newerX and navel in the tests.
*
# Revision 1.1  1992/08/19  02:02:34  richards
# Initial revision
#
*
*
"

_AddSlotsIfAbsent: (| myview. eqnview. foo. bar. fizz. baz. loo. |)

viewManager shutdown
pathCache refill
aa views topView topViewInitialise.
myview: aa topView copy
'copied...' print
'init...' print
myview debugFlag: true
myview name: 'An Algebra assistant named AA'
'named...' print
myview realise
'realised...' print
myview map
'mapped...' print
myview display flush

foo: aa scalar create: '!a!' Boite: aa x11symbols symbolNamed: 'alpha'
bar: aa scalar create: '!b!' Boite: aa x11symbols symbolNamed: 'beta'
loo: aa scalar create: '!i!' Boite: aa x11symbols symbolNamed: 'iota'
fizz: aa scalar create: '!c!' Boite: aa x11symbols symbolNamed: 'gamma'

baz: ((foo + fizz) / bar) * fizz 
baz printLine

myview masterEquation: baz.
myview stackEquationAt: 1 Put: ((foo * fizz) + loo).






