"lwView.self,v 1.3 1993/07/18 20:24:08 richards Exp "
" light weight views - X widgets that don't have corresponding X structure "

" A lwview must minimally have a superView, a manager, and a window "
" A lwview may be part of a compound view, but currently may not be "
" compound view. "

traits views _AddSlotsIfAbsent: (| ^ lwView = () |)
traits views lwView _Define: (|
    parent*** = traits abstractView.
    identity** = mixins identity.

    window  = ( heavySuperView window ).
    manager = ( heavySuperView manager ). 
    ^ isRealised = (heavySuperView isNil ifTrue: [ ^false. ] False: [ ^heavySuperView isLive ]).
    ^ isReal = (isRealised).
    ^ isHeavy = (false).
    ^ isLight = (true).
    
    ^ setSuperView: sv = (
	superView: sv.
	sv isNil ifFalse: [
	    heavySuperView: sv heavySuperView.
	].
    ).

    realising* = (|
	realise = (42).
	unrealise = (42).
	basicUnrealise = (42).
    |).

    mapping* = (|
	map = (42).
	unmap = (42).
    |).

    printing* = (|
	printString = ('viewLite: ',iName).
    |).

    drawing* = (|
	drawAt: p String: s = (
	    heavySuperView drawAt: p String: s
	).
	drawAt: p String: s InFont: fontStruct = (
	    heavySuperView drawAt: p String: s InFont: fontStruct
	).
	drawFrom: o To: c Width: w = (
	    heavySuperView drawFrom: o To: c Width: w
	).
	drawFrom: o To: c = (
	    heavySuperVIew drawFrom: o To: c
	).
	drawLine: r = (
	    heavySuperView drawLine: r
	).
	drawFrom: o For: c = (
	    heavySuperView drawFrom: o For: c
	).
	drawXorRectangleFrom: o To: c = (
	    heavySuperView drawXorRectangleFrom: o To: c
	).
	drawXorRectangle: rect = (
	    heavySuperView drawXorRectangle: rect
	).
    |).

    fonts* = (|
	drawAt: p String: s InFontNamed: fname = (
	    heavySuperView drawAt: p String: s InFontNamed: fname
	).
	drawInFixedFontAt: p String: s = (
	    heavySuperView drawInFixedFontAt: p String: s
	).
	openFontNamed: fname = (
	    heavySuperView openFontNamed: fname
	).
    |).
|)

prototypes views _AddSlotsIfAbsent: (| ^lwView = () |)
prototypes views lwView _Define: prototypes views abstractView
prototypes views lwView _AddSlots: (|
    parent* = traits lwView.
    ^_ heavySuperView <- nil.
|)

